(* This file is generated by Why3's Coq driver *)
(* Beware! Only edit allowed sections below    *)
Require Import BuiltIn.
Require BuiltIn.
Require int.Int.
Require list.List.
Require list.Length.
Require list.Mem.
Require list.Append.

(* Why3 assumption *)
Definition unit := unit.

Axiom set : forall (a:Type), Type.
Parameter set_WhyType : forall (a:Type) {a_WT:WhyType a}, WhyType (set a).
Existing Instance set_WhyType.

Parameter mem: forall {a:Type} {a_WT:WhyType a}, a -> (set a) -> Prop.

(* Why3 assumption *)
Definition infix_eqeq {a:Type} {a_WT:WhyType a} (s1:(set a)) (s2:(set
  a)): Prop := forall (x:a), (mem x s1) <-> (mem x s2).

Axiom extensionality : forall {a:Type} {a_WT:WhyType a}, forall (s1:(set a))
  (s2:(set a)), (infix_eqeq s1 s2) -> (s1 = s2).

(* Why3 assumption *)
Definition subset {a:Type} {a_WT:WhyType a} (s1:(set a)) (s2:(set
  a)): Prop := forall (x:a), (mem x s1) -> (mem x s2).

Axiom subset_refl : forall {a:Type} {a_WT:WhyType a}, forall (s:(set a)),
  (subset s s).

Axiom subset_trans : forall {a:Type} {a_WT:WhyType a}, forall (s1:(set a))
  (s2:(set a)) (s3:(set a)), (subset s1 s2) -> ((subset s2 s3) -> (subset s1
  s3)).

Parameter empty: forall {a:Type} {a_WT:WhyType a}, (set a).

(* Why3 assumption *)
Definition is_empty {a:Type} {a_WT:WhyType a} (s:(set a)): Prop :=
  forall (x:a), ~ (mem x s).

Axiom empty_def1 : forall {a:Type} {a_WT:WhyType a}, (is_empty (empty : (set
  a))).

Axiom mem_empty : forall {a:Type} {a_WT:WhyType a}, forall (x:a), ~ (mem x
  (empty : (set a))).

Parameter add: forall {a:Type} {a_WT:WhyType a}, a -> (set a) -> (set a).

Axiom add_def1 : forall {a:Type} {a_WT:WhyType a}, forall (x:a) (y:a),
  forall (s:(set a)), (mem x (add y s)) <-> ((x = y) \/ (mem x s)).

Parameter remove: forall {a:Type} {a_WT:WhyType a}, a -> (set a) -> (set a).

Axiom remove_def1 : forall {a:Type} {a_WT:WhyType a}, forall (x:a) (y:a)
  (s:(set a)), (mem x (remove y s)) <-> ((~ (x = y)) /\ (mem x s)).

Axiom add_remove : forall {a:Type} {a_WT:WhyType a}, forall (x:a) (s:(set
  a)), (mem x s) -> ((add x (remove x s)) = s).

Axiom remove_add : forall {a:Type} {a_WT:WhyType a}, forall (x:a) (s:(set
  a)), ((remove x (add x s)) = (remove x s)).

Axiom subset_remove : forall {a:Type} {a_WT:WhyType a}, forall (x:a) (s:(set
  a)), (subset (remove x s) s).

Parameter union: forall {a:Type} {a_WT:WhyType a}, (set a) -> (set a) -> (set
  a).

Axiom union_def1 : forall {a:Type} {a_WT:WhyType a}, forall (s1:(set a))
  (s2:(set a)) (x:a), (mem x (union s1 s2)) <-> ((mem x s1) \/ (mem x s2)).

Parameter inter: forall {a:Type} {a_WT:WhyType a}, (set a) -> (set a) -> (set
  a).

Axiom inter_def1 : forall {a:Type} {a_WT:WhyType a}, forall (s1:(set a))
  (s2:(set a)) (x:a), (mem x (inter s1 s2)) <-> ((mem x s1) /\ (mem x s2)).

Parameter diff: forall {a:Type} {a_WT:WhyType a}, (set a) -> (set a) -> (set
  a).

Axiom diff_def1 : forall {a:Type} {a_WT:WhyType a}, forall (s1:(set a))
  (s2:(set a)) (x:a), (mem x (diff s1 s2)) <-> ((mem x s1) /\ ~ (mem x s2)).

Axiom subset_diff : forall {a:Type} {a_WT:WhyType a}, forall (s1:(set a))
  (s2:(set a)), (subset (diff s1 s2) s1).

Parameter choose: forall {a:Type} {a_WT:WhyType a}, (set a) -> a.

Axiom choose_def : forall {a:Type} {a_WT:WhyType a}, forall (s:(set a)),
  (~ (is_empty s)) -> (mem (choose s) s).

Parameter cardinal: forall {a:Type} {a_WT:WhyType a}, (set a) -> Z.

Axiom cardinal_nonneg : forall {a:Type} {a_WT:WhyType a}, forall (s:(set a)),
  (0%Z <= (cardinal s))%Z.

Axiom cardinal_empty : forall {a:Type} {a_WT:WhyType a}, forall (s:(set a)),
  ((cardinal s) = 0%Z) <-> (is_empty s).

Axiom cardinal_add : forall {a:Type} {a_WT:WhyType a}, forall (x:a),
  forall (s:(set a)), (~ (mem x s)) -> ((cardinal (add x
  s)) = (1%Z + (cardinal s))%Z).

Axiom cardinal_remove : forall {a:Type} {a_WT:WhyType a}, forall (x:a),
  forall (s:(set a)), (mem x s) -> ((cardinal s) = (1%Z + (cardinal (remove x
  s)))%Z).

Axiom cardinal_subset : forall {a:Type} {a_WT:WhyType a}, forall (s1:(set a))
  (s2:(set a)), (subset s1 s2) -> ((cardinal s1) <= (cardinal s2))%Z.

Axiom subset_eq : forall {a:Type} {a_WT:WhyType a}, forall (s1:(set a))
  (s2:(set a)), (subset s1 s2) -> (((cardinal s1) = (cardinal s2)) ->
  (infix_eqeq s1 s2)).

Axiom cardinal1 : forall {a:Type} {a_WT:WhyType a}, forall (s:(set a)),
  ((cardinal s) = 1%Z) -> forall (x:a), (mem x s) -> (x = (choose s)).

(* Why3 assumption *)
Fixpoint elements {a:Type} {a_WT:WhyType a} (l:(list a)) {struct l}: (set
  a) :=
  match l with
  | Init.Datatypes.nil => (empty : (set a))
  | (Init.Datatypes.cons x r) => (add x (elements r))
  end.

Axiom elements_mem : forall {a:Type} {a_WT:WhyType a}, forall (x:a)
  (l:(list a)), (list.Mem.mem x l) <-> (mem x (elements l)).

Axiom vertex : Type.
Parameter vertex_WhyType : WhyType vertex.
Existing Instance vertex_WhyType.

Parameter vertices: (set vertex).

Parameter successors: vertex -> (set vertex).

Axiom successors_vertices : forall (x:vertex), (mem x vertices) -> (subset
  (successors x) vertices).

(* Why3 assumption *)
Definition edge (x:vertex) (y:vertex): Prop := (mem x vertices) /\ (mem y
  (successors x)).

(* Why3 assumption *)
Inductive path: vertex -> (list vertex) -> vertex -> Prop :=
  | Path_empty : forall (x:vertex), (path x Init.Datatypes.nil x)
  | Path_cons : forall (x:vertex) (y:vertex) (z:vertex) (l:(list vertex)),
      (edge x y) -> ((path y l z) -> (path x (Init.Datatypes.cons x l) z)).

Axiom path_right_extension : forall (x:vertex) (y:vertex) (z:vertex)
  (l:(list vertex)), (path x l y) -> ((edge y z) -> (path x
  (Init.Datatypes.app l (Init.Datatypes.cons y Init.Datatypes.nil)) z)).

Axiom path_right_inversion : forall (x:vertex) (z:vertex) (l:(list vertex)),
  (path x l z) -> (((x = z) /\ (l = Init.Datatypes.nil)) \/ exists y:vertex,
  exists l':(list vertex), (path x l' y) /\ ((edge y z) /\
  (l = (Init.Datatypes.app l' (Init.Datatypes.cons y Init.Datatypes.nil))))).

Axiom path_trans : forall (x:vertex) (y:vertex) (z:vertex) (l1:(list vertex))
  (l2:(list vertex)), (path x l1 y) -> ((path y l2 z) -> (path x
  (Init.Datatypes.app l1 l2) z)).

Axiom empty_path : forall (x:vertex) (y:vertex), (path x Init.Datatypes.nil
  y) -> (x = y).

Axiom path_decomposition : forall (x:vertex) (y:vertex) (z:vertex)
  (l1:(list vertex)) (l2:(list vertex)), (path x
  (Init.Datatypes.app l1 (Init.Datatypes.cons y l2)) z) -> ((path x l1 y) /\
  (path y (Init.Datatypes.cons y l2) z)).

(* Why3 assumption *)
Definition white_vertex (x:vertex) (v:(set vertex)): Prop := ~ (mem x v).

(* Why3 assumption *)
Inductive wpath: vertex -> (list vertex) -> vertex -> (set vertex) -> Prop :=
  | WPath_empty : forall (x:vertex) (v:(set vertex)), (white_vertex x v) ->
      (wpath x Init.Datatypes.nil x v)
  | WPath_cons : forall (x:vertex) (y:vertex) (l:(list vertex)) (z:vertex)
      (v:(set vertex)), (white_vertex x v) -> ((edge x y) -> ((wpath y l z
      v) -> (wpath x (Init.Datatypes.cons x l) z v))).

(* Why3 assumption *)
Definition whiteaccess (roots:(set vertex)) (b:(set vertex)) (v:(set
  vertex)): Prop := forall (z:vertex), (mem z b) -> exists x:vertex,
  exists l:(list vertex), (mem x roots) /\ (wpath x l z v).

(* Why3 assumption *)
Definition nbtw (b:(set vertex)) (v:(set vertex)): Prop := forall (x:vertex)
  (x':vertex), (edge x x') -> ((mem x b) -> (mem x' (union b v))).

Axiom whiteaccess_var : forall (r:(set vertex)) (r':(set vertex)) (b:(set
  vertex)) (v:(set vertex)), (subset r r') -> ((whiteaccess r b v) ->
  (whiteaccess r' b v)).

Axiom whiteaccess_minus : forall (r:(set vertex)) (s:(set vertex)) (v:(set
  vertex)), (whiteaccess r s v) <-> (whiteaccess (diff r v) s v).

Axiom nbtw_path : forall (v:(set vertex)) (v':(set vertex)), (nbtw (diff v'
  v) v) -> forall (x:vertex) (l:(list vertex)) (z:vertex), (mem x (diff v'
  v)) -> ((wpath x l z v) -> (mem z (diff v' v))).

Axiom nbtw_access : forall (v:(set vertex)) (v':(set vertex)), (nbtw (diff v'
  v) v) -> forall (r:(set vertex)) (s:(set vertex)), (subset r (diff v'
  v)) -> ((whiteaccess r s v) -> (subset s (diff v' v))).

Require Import mathcomp.ssreflect.ssreflect.


Require Import mathcomp.ssreflect.ssreflect.
Ltac compress := 
 repeat (match goal with [H1: ?A, H2: ?A |- _] => clear H2 end). 

(* Why3 goal *)
Theorem WP_parameter_dfs : forall (r:(set vertex)) (g:(set vertex)) (b:(set
  vertex)), ((subset r vertices) /\ ((subset b vertices) /\ ((infix_eqeq
  (inter b g) (empty : (set vertex))) /\ (subset g vertices)))) ->
  ((~ (is_empty r)) -> let x := (choose r) in let r' := (remove x r) in
  ((~ (mem x (union b g))) -> let o := (add x g) in let o1 :=
  (successors x) in (((subset o1 vertices) /\ ((subset b vertices) /\
  ((infix_eqeq (inter b o) (empty : (set vertex))) /\ (subset o
  vertices)))) -> forall (v':(set vertex)), ((subset v' vertices) /\ ((subset
  b v') /\ ((infix_eqeq (inter v' o) (empty : (set vertex))) /\ ((subset
  (diff o1 o) v') /\ ((nbtw (diff v' b) (union b o)) /\ forall (s:(set
  vertex)), (whiteaccess o1 s (union b o)) -> (subset s (diff v' b))))))) ->
  ((infix_eqeq (diff (add x v') b) (add x (diff v' b))) -> let o2 := (add x
  v') in (((subset r' vertices) /\ ((subset o2 vertices) /\ ((infix_eqeq
  (inter o2 g) (empty : (set vertex))) /\ (subset g vertices)))) ->
  forall (v'':(set vertex)), ((subset v'' vertices) /\ ((subset o2 v'') /\
  ((infix_eqeq (inter v'' g) (empty : (set vertex))) /\ ((subset (diff r' g)
  v'') /\ ((nbtw (diff v'' o2) (union o2 g)) /\ forall (s:(set vertex)),
  (whiteaccess r' s (union o2 g)) -> (subset s (diff v'' o2))))))) ->
  ((infix_eqeq (diff v'' b) (union (diff v'' (add x v')) (diff (add x v')
  b))) -> ((subset (diff r g) v'') -> ((nbtw (diff v'' b) (union b g)) ->
  forall (s:(set vertex)), (whiteaccess r s (union b g)) -> (subset s
  (diff v'' b)))))))))).
(* Why3 intros r g b (h1,(h2,(h3,h4))) h5 x r' h6 o o1 (h7,(h8,(h9,h10))) v'
        (h11,(h12,(h13,(h14,(h15,h16))))) h17 o2 (h18,(h19,(h20,h21))) v''
        (h22,(h23,(h24,(h25,(h26,h27))))) h28 h29 h30 s h31. *)
(* Why3 
intros r g b [h1,[h2,[h3,h4))) h5 x r' h6 o o1 [h7,[h8,[h9,h10))) v'
[h11,[h12,[h13,[h14,[h15,h16))))) h17 o2 [h18,[h19,[h20,h21))) v''
[h22,[h23,[h24,[h25,[h26,h27))))) h28 h29 h30 s H31. *)


 move=> r g b [h1 [h2 [h3 h4]]] h5 x r' h6 o o1 [h7 [h8 [h9 h10]]] v'
        [h11 [h12 [h13 [h14 [h15 h16]]]]] h17 o2 [h18 [h19 [h20 h21]]] v''
        [h22 [h23 [hempty_v''g [h25 [h26 h27]]]]] h28 hsub_rgv'' hnbtw_v''bbg s hwacc_rsbg. 

set v := (union b g).

have eq_diffv''v_diffv''b: diff v'' v = diff v'' b.
  + apply extensionality.
    split.
    - move => mem_x0v''v.
      apply diff_def1.
      move/diff_def1 :mem_x0v''v => [mem_x0v'' nmem_x0v].
      split; first by [].
      move => mem_x0g; apply nmem_x0v.  
      by apply union_def1; left.
    - move => mem_x0v''b.
      apply diff_def1.
      move/diff_def1 :mem_x0v''b => [mem_x0v'' nmem_x0b].
      split; first by [].
      move => mem_x0v.
      apply nmem_x0b.
      Check union_def1.
      apply union_def1 in mem_x0v.
      move :mem_x0v => [mem1 | mem2]; first by [].
      have hh: mem x0 (inter v'' g).
      + apply inter_def1.
        by split.
      apply hempty_v''g in hh.
      by apply mem_empty in hh.

have hwacc_rvsv: whiteaccess (diff r v) s v.
- by apply (whiteaccess_minus r). 
have hwacc_rgsv: whiteaccess (diff r g) s v.
- apply (whiteaccess_var (diff r v)); last by [].
  move => x0 mem_x0diffrv.
  apply diff_def1.
  move/diff_def1 :mem_x0diffrv => [mem_x0r nmem_x0v].
  split; first by [].
  move => mem_x0g; apply nmem_x0v.
  by apply union_def1; right.
have hwacc_v''sv: whiteaccess v'' s v.
- by apply (whiteaccess_var (diff r g)).
have hwacc_v''vsv: whiteaccess (diff v'' v) s v.
- by apply (whiteaccess_minus v'').
have hnbtw_v''vv: nbtw (diff v'' v) v.
- by rewrite eq_diffv''v_diffv''b.
have sub1: subset s (diff v'' v).
- by apply (nbtw_access v v'' hnbtw_v''vv (diff v'' v) ).

by rewrite - eq_diffv''v_diffv''b.
Qed.

